package com.neusoft.smart.pos.order.persistent.domain;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class OrderRefundExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer offset;

    private Integer limit;

    public OrderRefundExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
        this.offset = null;
        this.limit = null;
    }

    public Integer getOffset() {
        return this.offset;
    }

    public void setOffset(Integer offset) {
        this.offset = offset;
    }

    public Integer getLimit() {
        return this.limit;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public OrderRefundExample page(int offset, int limit) {
        this.offset = offset;
        this.limit = limit;
        return this;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andRefundNumberIsNull() {
            addCriterion("refund_number is null");
            return (Criteria) this;
        }

        public Criteria andRefundNumberIsNotNull() {
            addCriterion("refund_number is not null");
            return (Criteria) this;
        }

        public Criteria andRefundNumberEqualTo(String value) {
            addCriterion("refund_number =", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberNotEqualTo(String value) {
            addCriterion("refund_number <>", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberGreaterThan(String value) {
            addCriterion("refund_number >", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberGreaterThanOrEqualTo(String value) {
            addCriterion("refund_number >=", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberLessThan(String value) {
            addCriterion("refund_number <", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberLessThanOrEqualTo(String value) {
            addCriterion("refund_number <=", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberLike(String value) {
            addCriterion("refund_number like", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberNotLike(String value) {
            addCriterion("refund_number not like", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberIn(List<String> values) {
            addCriterion("refund_number in", values, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberNotIn(List<String> values) {
            addCriterion("refund_number not in", values, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberBetween(String value1, String value2) {
            addCriterion("refund_number between", value1, value2, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberNotBetween(String value1, String value2) {
            addCriterion("refund_number not between", value1, value2, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andSellerOrgIdIsNull() {
            addCriterion("seller_org_id is null");
            return (Criteria) this;
        }

        public Criteria andSellerOrgIdIsNotNull() {
            addCriterion("seller_org_id is not null");
            return (Criteria) this;
        }

        public Criteria andSellerOrgIdEqualTo(Integer value) {
            addCriterion("seller_org_id =", value, "sellerOrgId");
            return (Criteria) this;
        }

        public Criteria andSellerOrgIdNotEqualTo(Integer value) {
            addCriterion("seller_org_id <>", value, "sellerOrgId");
            return (Criteria) this;
        }

        public Criteria andSellerOrgIdGreaterThan(Integer value) {
            addCriterion("seller_org_id >", value, "sellerOrgId");
            return (Criteria) this;
        }

        public Criteria andSellerOrgIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("seller_org_id >=", value, "sellerOrgId");
            return (Criteria) this;
        }

        public Criteria andSellerOrgIdLessThan(Integer value) {
            addCriterion("seller_org_id <", value, "sellerOrgId");
            return (Criteria) this;
        }

        public Criteria andSellerOrgIdLessThanOrEqualTo(Integer value) {
            addCriterion("seller_org_id <=", value, "sellerOrgId");
            return (Criteria) this;
        }

        public Criteria andSellerOrgIdIn(List<Integer> values) {
            addCriterion("seller_org_id in", values, "sellerOrgId");
            return (Criteria) this;
        }

        public Criteria andSellerOrgIdNotIn(List<Integer> values) {
            addCriterion("seller_org_id not in", values, "sellerOrgId");
            return (Criteria) this;
        }

        public Criteria andSellerOrgIdBetween(Integer value1, Integer value2) {
            addCriterion("seller_org_id between", value1, value2, "sellerOrgId");
            return (Criteria) this;
        }

        public Criteria andSellerOrgIdNotBetween(Integer value1, Integer value2) {
            addCriterion("seller_org_id not between", value1, value2, "sellerOrgId");
            return (Criteria) this;
        }

        public Criteria andSellerShopIdIsNull() {
            addCriterion("seller_shop_id is null");
            return (Criteria) this;
        }

        public Criteria andSellerShopIdIsNotNull() {
            addCriterion("seller_shop_id is not null");
            return (Criteria) this;
        }

        public Criteria andSellerShopIdEqualTo(Integer value) {
            addCriterion("seller_shop_id =", value, "sellerShopId");
            return (Criteria) this;
        }

        public Criteria andSellerShopIdNotEqualTo(Integer value) {
            addCriterion("seller_shop_id <>", value, "sellerShopId");
            return (Criteria) this;
        }

        public Criteria andSellerShopIdGreaterThan(Integer value) {
            addCriterion("seller_shop_id >", value, "sellerShopId");
            return (Criteria) this;
        }

        public Criteria andSellerShopIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("seller_shop_id >=", value, "sellerShopId");
            return (Criteria) this;
        }

        public Criteria andSellerShopIdLessThan(Integer value) {
            addCriterion("seller_shop_id <", value, "sellerShopId");
            return (Criteria) this;
        }

        public Criteria andSellerShopIdLessThanOrEqualTo(Integer value) {
            addCriterion("seller_shop_id <=", value, "sellerShopId");
            return (Criteria) this;
        }

        public Criteria andSellerShopIdIn(List<Integer> values) {
            addCriterion("seller_shop_id in", values, "sellerShopId");
            return (Criteria) this;
        }

        public Criteria andSellerShopIdNotIn(List<Integer> values) {
            addCriterion("seller_shop_id not in", values, "sellerShopId");
            return (Criteria) this;
        }

        public Criteria andSellerShopIdBetween(Integer value1, Integer value2) {
            addCriterion("seller_shop_id between", value1, value2, "sellerShopId");
            return (Criteria) this;
        }

        public Criteria andSellerShopIdNotBetween(Integer value1, Integer value2) {
            addCriterion("seller_shop_id not between", value1, value2, "sellerShopId");
            return (Criteria) this;
        }

        public Criteria andSellerCustomerNumberIsNull() {
            addCriterion("seller_customer_number is null");
            return (Criteria) this;
        }

        public Criteria andSellerCustomerNumberIsNotNull() {
            addCriterion("seller_customer_number is not null");
            return (Criteria) this;
        }

        public Criteria andSellerCustomerNumberEqualTo(String value) {
            addCriterion("seller_customer_number =", value, "sellerCustomerNumber");
            return (Criteria) this;
        }

        public Criteria andSellerCustomerNumberNotEqualTo(String value) {
            addCriterion("seller_customer_number <>", value, "sellerCustomerNumber");
            return (Criteria) this;
        }

        public Criteria andSellerCustomerNumberGreaterThan(String value) {
            addCriterion("seller_customer_number >", value, "sellerCustomerNumber");
            return (Criteria) this;
        }

        public Criteria andSellerCustomerNumberGreaterThanOrEqualTo(String value) {
            addCriterion("seller_customer_number >=", value, "sellerCustomerNumber");
            return (Criteria) this;
        }

        public Criteria andSellerCustomerNumberLessThan(String value) {
            addCriterion("seller_customer_number <", value, "sellerCustomerNumber");
            return (Criteria) this;
        }

        public Criteria andSellerCustomerNumberLessThanOrEqualTo(String value) {
            addCriterion("seller_customer_number <=", value, "sellerCustomerNumber");
            return (Criteria) this;
        }

        public Criteria andSellerCustomerNumberLike(String value) {
            addCriterion("seller_customer_number like", value, "sellerCustomerNumber");
            return (Criteria) this;
        }

        public Criteria andSellerCustomerNumberNotLike(String value) {
            addCriterion("seller_customer_number not like", value, "sellerCustomerNumber");
            return (Criteria) this;
        }

        public Criteria andSellerCustomerNumberIn(List<String> values) {
            addCriterion("seller_customer_number in", values, "sellerCustomerNumber");
            return (Criteria) this;
        }

        public Criteria andSellerCustomerNumberNotIn(List<String> values) {
            addCriterion("seller_customer_number not in", values, "sellerCustomerNumber");
            return (Criteria) this;
        }

        public Criteria andSellerCustomerNumberBetween(String value1, String value2) {
            addCriterion("seller_customer_number between", value1, value2, "sellerCustomerNumber");
            return (Criteria) this;
        }

        public Criteria andSellerCustomerNumberNotBetween(String value1, String value2) {
            addCriterion("seller_customer_number not between", value1, value2, "sellerCustomerNumber");
            return (Criteria) this;
        }

        public Criteria andSerialNoIsNull() {
            addCriterion("serial_no is null");
            return (Criteria) this;
        }

        public Criteria andSerialNoIsNotNull() {
            addCriterion("serial_no is not null");
            return (Criteria) this;
        }

        public Criteria andSerialNoEqualTo(String value) {
            addCriterion("serial_no =", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoNotEqualTo(String value) {
            addCriterion("serial_no <>", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoGreaterThan(String value) {
            addCriterion("serial_no >", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoGreaterThanOrEqualTo(String value) {
            addCriterion("serial_no >=", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoLessThan(String value) {
            addCriterion("serial_no <", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoLessThanOrEqualTo(String value) {
            addCriterion("serial_no <=", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoLike(String value) {
            addCriterion("serial_no like", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoNotLike(String value) {
            addCriterion("serial_no not like", value, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoIn(List<String> values) {
            addCriterion("serial_no in", values, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoNotIn(List<String> values) {
            addCriterion("serial_no not in", values, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoBetween(String value1, String value2) {
            addCriterion("serial_no between", value1, value2, "serialNo");
            return (Criteria) this;
        }

        public Criteria andSerialNoNotBetween(String value1, String value2) {
            addCriterion("serial_no not between", value1, value2, "serialNo");
            return (Criteria) this;
        }

        public Criteria andOriginalOrderNumberIsNull() {
            addCriterion("original_order_number is null");
            return (Criteria) this;
        }

        public Criteria andOriginalOrderNumberIsNotNull() {
            addCriterion("original_order_number is not null");
            return (Criteria) this;
        }

        public Criteria andOriginalOrderNumberEqualTo(String value) {
            addCriterion("original_order_number =", value, "originalOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOriginalOrderNumberNotEqualTo(String value) {
            addCriterion("original_order_number <>", value, "originalOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOriginalOrderNumberGreaterThan(String value) {
            addCriterion("original_order_number >", value, "originalOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOriginalOrderNumberGreaterThanOrEqualTo(String value) {
            addCriterion("original_order_number >=", value, "originalOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOriginalOrderNumberLessThan(String value) {
            addCriterion("original_order_number <", value, "originalOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOriginalOrderNumberLessThanOrEqualTo(String value) {
            addCriterion("original_order_number <=", value, "originalOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOriginalOrderNumberLike(String value) {
            addCriterion("original_order_number like", value, "originalOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOriginalOrderNumberNotLike(String value) {
            addCriterion("original_order_number not like", value, "originalOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOriginalOrderNumberIn(List<String> values) {
            addCriterion("original_order_number in", values, "originalOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOriginalOrderNumberNotIn(List<String> values) {
            addCriterion("original_order_number not in", values, "originalOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOriginalOrderNumberBetween(String value1, String value2) {
            addCriterion("original_order_number between", value1, value2, "originalOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOriginalOrderNumberNotBetween(String value1, String value2) {
            addCriterion("original_order_number not between", value1, value2, "originalOrderNumber");
            return (Criteria) this;
        }

        public Criteria andRefundableAmountIsNull() {
            addCriterion("refundable_amount is null");
            return (Criteria) this;
        }

        public Criteria andRefundableAmountIsNotNull() {
            addCriterion("refundable_amount is not null");
            return (Criteria) this;
        }

        public Criteria andRefundableAmountEqualTo(Long value) {
            addCriterion("refundable_amount =", value, "refundableAmount");
            return (Criteria) this;
        }

        public Criteria andRefundableAmountNotEqualTo(Long value) {
            addCriterion("refundable_amount <>", value, "refundableAmount");
            return (Criteria) this;
        }

        public Criteria andRefundableAmountGreaterThan(Long value) {
            addCriterion("refundable_amount >", value, "refundableAmount");
            return (Criteria) this;
        }

        public Criteria andRefundableAmountGreaterThanOrEqualTo(Long value) {
            addCriterion("refundable_amount >=", value, "refundableAmount");
            return (Criteria) this;
        }

        public Criteria andRefundableAmountLessThan(Long value) {
            addCriterion("refundable_amount <", value, "refundableAmount");
            return (Criteria) this;
        }

        public Criteria andRefundableAmountLessThanOrEqualTo(Long value) {
            addCriterion("refundable_amount <=", value, "refundableAmount");
            return (Criteria) this;
        }

        public Criteria andRefundableAmountIn(List<Long> values) {
            addCriterion("refundable_amount in", values, "refundableAmount");
            return (Criteria) this;
        }

        public Criteria andRefundableAmountNotIn(List<Long> values) {
            addCriterion("refundable_amount not in", values, "refundableAmount");
            return (Criteria) this;
        }

        public Criteria andRefundableAmountBetween(Long value1, Long value2) {
            addCriterion("refundable_amount between", value1, value2, "refundableAmount");
            return (Criteria) this;
        }

        public Criteria andRefundableAmountNotBetween(Long value1, Long value2) {
            addCriterion("refundable_amount not between", value1, value2, "refundableAmount");
            return (Criteria) this;
        }

        public Criteria andRefundStatusIsNull() {
            addCriterion("refund_status is null");
            return (Criteria) this;
        }

        public Criteria andRefundStatusIsNotNull() {
            addCriterion("refund_status is not null");
            return (Criteria) this;
        }

        public Criteria andRefundStatusEqualTo(String value) {
            addCriterion("refund_status =", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusNotEqualTo(String value) {
            addCriterion("refund_status <>", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusGreaterThan(String value) {
            addCriterion("refund_status >", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusGreaterThanOrEqualTo(String value) {
            addCriterion("refund_status >=", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusLessThan(String value) {
            addCriterion("refund_status <", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusLessThanOrEqualTo(String value) {
            addCriterion("refund_status <=", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusLike(String value) {
            addCriterion("refund_status like", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusNotLike(String value) {
            addCriterion("refund_status not like", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusIn(List<String> values) {
            addCriterion("refund_status in", values, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusNotIn(List<String> values) {
            addCriterion("refund_status not in", values, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusBetween(String value1, String value2) {
            addCriterion("refund_status between", value1, value2, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusNotBetween(String value1, String value2) {
            addCriterion("refund_status not between", value1, value2, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountIsNull() {
            addCriterion("refunded_amount is null");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountIsNotNull() {
            addCriterion("refunded_amount is not null");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountEqualTo(Long value) {
            addCriterion("refunded_amount =", value, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountNotEqualTo(Long value) {
            addCriterion("refunded_amount <>", value, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountGreaterThan(Long value) {
            addCriterion("refunded_amount >", value, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountGreaterThanOrEqualTo(Long value) {
            addCriterion("refunded_amount >=", value, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountLessThan(Long value) {
            addCriterion("refunded_amount <", value, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountLessThanOrEqualTo(Long value) {
            addCriterion("refunded_amount <=", value, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountIn(List<Long> values) {
            addCriterion("refunded_amount in", values, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountNotIn(List<Long> values) {
            addCriterion("refunded_amount not in", values, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountBetween(Long value1, Long value2) {
            addCriterion("refunded_amount between", value1, value2, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountNotBetween(Long value1, Long value2) {
            addCriterion("refunded_amount not between", value1, value2, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeIsNull() {
            addCriterion("refunded_time is null");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeIsNotNull() {
            addCriterion("refunded_time is not null");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeEqualTo(Date value) {
            addCriterion("refunded_time =", value, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeNotEqualTo(Date value) {
            addCriterion("refunded_time <>", value, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeGreaterThan(Date value) {
            addCriterion("refunded_time >", value, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("refunded_time >=", value, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeLessThan(Date value) {
            addCriterion("refunded_time <", value, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeLessThanOrEqualTo(Date value) {
            addCriterion("refunded_time <=", value, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeIn(List<Date> values) {
            addCriterion("refunded_time in", values, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeNotIn(List<Date> values) {
            addCriterion("refunded_time not in", values, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeBetween(Date value1, Date value2) {
            addCriterion("refunded_time between", value1, value2, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeNotBetween(Date value1, Date value2) {
            addCriterion("refunded_time not between", value1, value2, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andVersionIsNull() {
            addCriterion("version is null");
            return (Criteria) this;
        }

        public Criteria andVersionIsNotNull() {
            addCriterion("version is not null");
            return (Criteria) this;
        }

        public Criteria andVersionEqualTo(Integer value) {
            addCriterion("version =", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotEqualTo(Integer value) {
            addCriterion("version <>", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionGreaterThan(Integer value) {
            addCriterion("version >", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionGreaterThanOrEqualTo(Integer value) {
            addCriterion("version >=", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionLessThan(Integer value) {
            addCriterion("version <", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionLessThanOrEqualTo(Integer value) {
            addCriterion("version <=", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionIn(List<Integer> values) {
            addCriterion("version in", values, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotIn(List<Integer> values) {
            addCriterion("version not in", values, "version");
            return (Criteria) this;
        }

        public Criteria andVersionBetween(Integer value1, Integer value2) {
            addCriterion("version between", value1, value2, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotBetween(Integer value1, Integer value2) {
            addCriterion("version not between", value1, value2, "version");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(String value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(String value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(String value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(String value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(String value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(String value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLike(String value) {
            addCriterion("created_by like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotLike(String value) {
            addCriterion("created_by not like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<String> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<String> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(String value1, String value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(String value1, String value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIsNull() {
            addCriterion("updated_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIsNotNull() {
            addCriterion("updated_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedByEqualTo(String value) {
            addCriterion("updated_by =", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotEqualTo(String value) {
            addCriterion("updated_by <>", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByGreaterThan(String value) {
            addCriterion("updated_by >", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByGreaterThanOrEqualTo(String value) {
            addCriterion("updated_by >=", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLessThan(String value) {
            addCriterion("updated_by <", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLessThanOrEqualTo(String value) {
            addCriterion("updated_by <=", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLike(String value) {
            addCriterion("updated_by like", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotLike(String value) {
            addCriterion("updated_by not like", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIn(List<String> values) {
            addCriterion("updated_by in", values, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotIn(List<String> values) {
            addCriterion("updated_by not in", values, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByBetween(String value1, String value2) {
            addCriterion("updated_by between", value1, value2, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotBetween(String value1, String value2) {
            addCriterion("updated_by not between", value1, value2, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNull() {
            addCriterion("updated_at is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNotNull() {
            addCriterion("updated_at is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtEqualTo(Date value) {
            addCriterion("updated_at =", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotEqualTo(Date value) {
            addCriterion("updated_at <>", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThan(Date value) {
            addCriterion("updated_at >", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("updated_at >=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThan(Date value) {
            addCriterion("updated_at <", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThanOrEqualTo(Date value) {
            addCriterion("updated_at <=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIn(List<Date> values) {
            addCriterion("updated_at in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotIn(List<Date> values) {
            addCriterion("updated_at not in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtBetween(Date value1, Date value2) {
            addCriterion("updated_at between", value1, value2, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotBetween(Date value1, Date value2) {
            addCriterion("updated_at not between", value1, value2, "updatedAt");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}